<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>Plasma.DataContainer</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>DataContainer Class Reference</h1>
<code>from PyKDE4.plasma import *</code>
<p>
Inherits: <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a><br />

Namespace: Plasma<br />
<h2>Detailed Description</h2>

<p>DataContainer plasma/datacontainer.h &lt;Plasma/DataContainer&gt;
</p>
<p>
A set of data exported via a DataEngine
</p>
<p>
Plasma.DataContainer wraps the data exported by a DataEngine
implementation, providing a generic wrapper for the data.
</p>
<p>
A DataContainer may have zero or more associated pieces of data which
are keyed by strings. The data itself is stored as QVariants. This allows
easy and flexible retrieval of the information associated with this object
without writing DataContainer or DataEngine specific code in visualizations.
</p>
<p>
If you are creating your own DataContainer objects (and are passing them to
DataEngine.addSource()), you normally just need to listen to the
updateRequested() signal (as well as any other methods you might have of
being notified of new data) and call setData() to actually update the data.
Then you need to either trigger the scheduleSourcesUpdated signal of the
parent DataEngine or call checkForUpdate() on the DataContainer.
</p>
<p>
You also need to set a suitable name for the source with setObjectName().
See DataEngine.addSource() for more information.
</p>
<p>
Note that there is normally no need to subclass DataContainer, except as
a way of encapsulating the data retreival for a source, since all notifications
are done via signals rather than virtual methods.
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Signals</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj199515724">becameUnused</a> (<a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> source)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj199514124">dataUpdated</a> (<a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> source, Plasma.DataEngine.Data data)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj199514028">updateRequested</a> (<a href="../plasma/Plasma.DataContainer.html">Plasma.DataContainer</a> source)</td></tr>
<tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162631308">__init__</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a> parent=0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj199515724">becameUnused</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> source)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj163886860">checkForUpdate</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj181372172">checkUsage</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj171108236">connectVisualization</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a> visualization, long pollingInterval, Plasma.IntervalAlignment alignment)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">Plasma.DataEngine.Data&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162631212">data</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj199514124">dataUpdated</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> source, Plasma.DataEngine.Data data)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj171109164">disconnectVisualization</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a> visualization)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162871020">removeAllData</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj162871820">setData</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> key, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qvariant.html">QVariant</a> value)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj163887340">setNeedsUpdate</a> (self, bool update=1)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">long&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj163886028">timeSinceLastUpdate</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj199514028">updateRequested</a> (self, <a href="../plasma/Plasma.DataContainer.html">Plasma.DataContainer</a> source)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj172712140">visualizationIsConnected</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a> visualization)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj162631308"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>&nbsp;</td>
<td class="paramname"><em>parent=0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Constructs a default DataContainer that has no name or data
associated with it
</p></div></div><a class="anchor" name="obj199515724"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> becameUnused</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>source</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Emitted when the last visualization is disconnected.
</p>
<p>
Note that if this source was created by DataEngine.sourceRequestEvent(),
it will be deleted by DataEngine once control returns to the event loop
after this signal is emitted.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>source</em>&nbsp;</td><td> the name of the source that became unused
</td></tr>
</table></dl>
<p>
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("becameUnused(const QString&)"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj163886860"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> checkForUpdate</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Checks whether any data has changed and, if so, emits dataUpdated().
</p></div></div><a class="anchor" name="obj181372172"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> checkUsage</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Check if the DataContainer is still in use.
</p>
<p>
If not the signal "becameUnused" will be emitted.
</p>
<p>
Warning: The DataContainer may be invalid after calling this function, because a listener
to becameUnused() may have deleted it.
</p></div></div><a class="anchor" name="obj171108236"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> connectVisualization</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>&nbsp;</td>
<td class="paramname"><em>visualization</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">long&nbsp;</td>
<td class="paramname"><em>pollingInterval</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">Plasma.IntervalAlignment&nbsp;</td>
<td class="paramname"><em>alignment</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Connects an object to this DataContainer.
</p>
<p>
May be called repeatedly for the same visualization without
side effects
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>visualization</em>&nbsp;</td><td> the object to connect to this DataContainer

<tr><td></td><td valign="top"><em>pollingInterval</em>&nbsp;</td><td> the time in milliseconds between updates
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj162631212"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">Plasma.DataEngine.Data data</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Returns the data for this DataContainer
</p></div></div><a class="anchor" name="obj199514124"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> dataUpdated</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>source</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">Plasma.DataEngine.Data&nbsp;</td>
<td class="paramname"><em>data</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Emitted when the data has been updated, allowing visualizations to
reflect the new data.
</p>
<p>
Note that you should not normally emit this directly. Instead, use
checkForUpdates() or the DataEngine.scheduleSourcesUpdated() slot.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>source</em>&nbsp;</td><td> the objectName() of the DataContainer (and hence the name
of the source) that updated its data

<tr><td></td><td valign="top"><em>data</em>&nbsp;</td><td> the updated data
</td></tr>
</table></dl>
<p>
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("dataUpdated(const QString&, const Data&)"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj171109164"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> disconnectVisualization</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>&nbsp;</td>
<td class="paramname"><em>visualization</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Disconnects an object from this DataContainer.
</p>
<p>
Note that if this source was created by DataEngine.sourceRequestEvent(),
it will be deleted by DataEngine once control returns to the event loop.
</p></div></div><a class="anchor" name="obj162871020"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> removeAllData</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Removes all data currently associated with this source
</p>
<p>
If you call removeAllData() on a DataContainer, you need to
either trigger the scheduleSourcesUpdated() slot for the
data engine it belongs to or call checkForUpdate() on the
DataContainer.
</p></div></div><a class="anchor" name="obj162871820"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setData</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>key</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qvariant.html">QVariant</a>&nbsp;</td>
<td class="paramname"><em>value</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Set a value for a key.
</p>
<p>
This also marks this source as needing to signal an update.
</p>
<p>
If you call setData() directly on a DataContainer, you need to
either trigger the scheduleSourcesUpdated() slot for the
data engine it belongs to or call checkForUpdate() on the
DataContainer.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>key</em>&nbsp;</td><td> a string used as the key for the data

<tr><td></td><td valign="top"><em>value</em>&nbsp;</td><td> a QVariant holding the actual data. If a null or invalid
QVariant is passed in and the key currently exists in the
data, then the data entry is removed
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj163887340"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setNeedsUpdate</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>update=1</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Indicates that the data should be treated as dirty the next time hasUpdates() is called.
</p>
<p>
This is needed for the case where updateRequested() is triggered but we don't want to
update the data immediately because it has just been updated. The second request won't
be fulfilled in this case, because we never updated the data and so never called
checkForUpdate(). So we claim it needs an update anyway.
</p></div></div><a class="anchor" name="obj163886028"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">long timeSinceLastUpdate</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Returns how long ago, in msecs, that the data in this container was last updated.
</p>
<p>
This is used by DataEngine to compress updates that happen more quickly than the
minimum polling interval by calling setNeedsUpdate() instead of calling
updateSourceEvent() immediately.
</p></div></div><a class="anchor" name="obj199514028"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> updateRequested</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../plasma/Plasma.DataContainer.html">Plasma.DataContainer</a>&nbsp;</td>
<td class="paramname"><em>source</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Emitted when an update is requested.
</p>
<p>
If a polling interval was passed connectVisualization(), this signal
will be emitted every time the interval expires.
</p>
<p>
Note that if you create your own DataContainer (and pass it to
DataEngine.addSource()), you will need to listen to this signal
and refresh the data when it is triggered.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>source</em>&nbsp;</td><td> the datacontainer the update was requested for. Useful
for classes that update the data for several containers.
</td></tr>
</table></dl>
<p>
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("updateRequested(DataContainer*)"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj172712140"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool visualizationIsConnected</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>&nbsp;</td>
<td class="paramname"><em>visualization</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p><dl class="return" compact><dt><b>Returns:</b></dt><dd> true if the visualization is currently connected
</dd></dl>
</p></div></div>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
